//+------------------------------------------------------------------+
//|                                                DynamicMatrix.mqh |
//|                                                      nicholishen |
//|                            http://www.reddit.com/u/nicholishenFX |
//+------------------------------------------------------------------+
#property copyright "nicholishen"
#property link      "http://www.reddit.com/u/nicholishenFX"
#property version   "1.00"
#property strict
#include <Arrays\ArrayString.mqh>
#include <Arrays\ArrayObj.mqh>

template<typename T>
class TemplateData : public CObject
{
protected:
   T           m_data;
   string      m_type;
public:
   TemplateData():m_data(NULL),m_type("void"){}
   T           Data()      const { return m_data;     }
   string      DataType()  const { return m_type;     }
   template<typename T2>
   void        Data(const T2 data)           { m_type = typename(data); m_data = (T)data;}
   template<typename T2>
   void        operator = (const T2 data)    { Data(data); }
   void        DataType(const string type)   { m_type = type;}
};
//+------------------------------------------------------------------+
template<typename T>
class ColumnVector : public CArrayObj
{
public:
   TemplateData<T>* operator[](const int index)
   {
      if(index < Total())  
         return (TemplateData<T>*)At(index); 
      TemplateData<T> *ptr = NULL;
      while(index >= Total())
      {
         ptr = new TemplateData<T>();
         Add(ptr);
      }
      return ptr;
   }
};
//+------------------------------------------------------------------+
template<typename T>
class CDynamicMatrix : public CObject // row vector
{
protected:
   CArrayObj m_arr;
public:
   ColumnVector<T>* operator[](const int index)
   {
      if(index < m_arr.Total())
         return (ColumnVector<T>*)m_arr.At(index);
      ColumnVector<T> *ptr = NULL;
      while(index >= m_arr.Total())
      {
         ptr = new ColumnVector<T>();
         m_arr.Add(ptr);
      }
      return ptr;
   }
   template<typename T2>
   void Set(const int row,const int column,const T2 data)
   {
      this[row][column].Data(data);
   }
   void Set(const int row,const int column,const string data,const string type)
   {
      this[row][column].Data(data);
      this[row][column].DataType(type);
   }
   template<typename T2>
   void  Get(const int row,const int column,T2 &data)
   {
      data = (T2)this[row][column].Data();
   }
   int Total()const { return m_arr.Total(); }
   void Clear() { m_arr.Clear(); }
};
//+------------------------------------------------------------------+